MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
sc::auto_vec< T > Class Template Reference

The auto_vec class functions much like auto_ptr, except it contains references to arrays. More...

`#include <autovec.h>`

## Public Types
typedef T | element_type

## Public Member Functions
| auto_vec (T *d=0) throw ()
| Creates a new auto_vec for a vector, d, of type T. More...
| auto_vec (auto_vec &av) throw ()
| Create a auto_vec, transferring the storage from another. More...
| ~auto_vec () throw ()
| This will delete the vector. More...
auto_vec & | operator= (auto_vec &av) throw ()
| This member transfers the data from av to this. More...
T * | get () const throw ()
| Returns the pointer. More...
T & | operator[] (size_t i) throw ()
| Returns the i'th element. More...
T * | release () throw ()
| Release ownership. More...
void | reset (T *d=0) throw ()
| Assign to a new value. More...

## Detailed Description

### template<class T>
class sc::auto_vec< T >

The auto_vec class functions much like auto_ptr, except it contains references to arrays.

The delete[] operator will be used to deallocate data.

## Constructor & Destructor Documentation

template<class T>

sc::auto_vec< T >::auto_vec | ( | T * | d = `0` | ) | throw ()
| inline explicit

Creates a new auto_vec for a vector, d, of type T.

The d argument must be created with the vector new operator: new T[...].

template<class T>

sc::auto_vec< T >::auto_vec | ( | auto_vec< T > & | av | ) | throw ()
| inline

Create a auto_vec, transferring the storage from another.

template<class T>

sc::auto_vec< T >::~auto_vec | ( |  | ) | throw ()
| inline

This will delete the vector.

## Member Function Documentation

template<class T>

T* sc::auto_vec< T >::get | ( |  | ) | const throw ()
| inline

Returns the pointer.

template<class T>

auto_vec& sc::auto_vec< T >::operator= | ( | auto_vec< T > & | av | ) | throw ()
| inline

This member transfers the data from av to this.

template<class T>

T& sc::auto_vec< T >::operator[] | ( | size_t | i | ) | throw ()
| inline

Returns the i'th element.

template<class T>

T* sc::auto_vec< T >::release | ( |  | ) | throw ()
| inline

Release ownership.

template<class T>

void sc::auto_vec< T >::reset | ( | T * | d = `0` | ) | throw ()
| inline

Assign to a new value.

Referenced by sc::auto_vec< double >::operator=().

The documentation for this class was generated from the following file:

- autovec.h